#include <Stepper.h> 
#include <Servo.h>


#define dirPinX 2
#define stepPinX 3
#define dirPinY 6
#define stepPinY 7
#define STEPS 200
#define controllerX A1
#define controllerY A0
#define servoControll 11
#define button 13
#define debounceDelay 50

Stepper stepperX(STEPS, dirPinX, stepPinX);
Stepper stepperY(STEPS, dirPinY, stepPinY);

Servo myservo;

int xValue;
int yValue;
int buttonValue;

int servopoz = 0;
int prevValue = 1;
long lastDebounceTime = 0;

bool servoverify = false;
long pressedButtonTime = 0;

int moveX = 0;
int moveY = 0;

void servomove() {

  if(servoverify) {
    if(millis() - pressedButtonTime > debounceDelay * 5) {
      servopoz = 1 - servopoz;
      myservo.write(servopoz * 180);
      servoverify = false;
    }
    if(buttonValue == 1) {
      servoverify = false;

    }

  }
  if(prevValue == 1 && buttonValue == 0) {
    servoverify = true;
    pressedButtonTime = millis();
  }
  prevValue = buttonValue;
  lastDebounceTime = millis();

}

void moveMotors() {
  for(int i = 0 ; i < 200 ; i++) {
    stepperX.step(moveX);
    stepperY.step(moveY);
  }
}
void setup()
{
  //MOTORS OUTPUT PINS INIT
	pinMode(stepPinX, OUTPUT);
	pinMode(dirPinX, OUTPUT);
	pinMode(stepPinY, OUTPUT);
	pinMode(dirPinY, OUTPUT);
  //SETUP SERIAL MONITOR
  Serial.begin(9600) ;
  digitalWrite(dirPinX, HIGH);

  stepperX.setSpeed(500);
  stepperY.setSpeed(500);

  myservo.attach(servoControll);
}
void loop()
{
  xValue = analogRead(controllerX);
  yValue = analogRead(controllerY);
  buttonValue = digitalRead(button);


  if(xValue < 100)
    moveX = -1;
  else if(xValue > 913)
    moveX = 1;
  else
    moveX = 0;

  if(yValue < 100)
    moveY = -1;
  else if(yValue > 913)
    moveY = 1;
  else
    moveY = 0;
  moveMotors();
  if ( (millis() - lastDebounceTime) > debounceDelay)
    servomove();
}